class CourseVideo < ApplicationRecord
  belongs_to :course
  belongs_to :video, optional: true
  belongs_to :user, optional: true

  validates :title, length: { maximum: 60, too_long: "不能超过60个字符" }, allow_blank: true
  validates :link, format: { with: CustomRegexp::URL, message: "必须为网址超链接" }, allow_blank: true

  has_many :watch_course_videos
end
