json.attendances @attendances do |attendance|
  json.(attendance, :id, :name, :normal_count, :all_count, :mode, :attendance_code)
  json.author do
    user = attendance.user
    json.user_name user.real_name
    json.user_login user.login
  end
  json.attendance_date attendance.attendance_date.strftime("%Y-%m-%d")
  json.start_time attendance.start_time.strftime("%H:%M")
  json.end_time attendance.end_time.strftime("%H:%M")
  json.edit_auth @user_course_identity < Course::PROFESSOR || attendance.user_id == User.current.id

  if @user_course_identity == Course::STUDENT
    student_attendance_status = student_attendance_status(attendance, User.current)
    json.attendance_status student_attendance_status[:attendance_status]
    json.attendance_mode student_attendance_status[:attendance_mode]
  end
end

json.attendances_count @attendances_count

if @user_course_identity == Course::STUDENT
  json.normal_count @normal_count
  json.leave_count @leave_count
  json.absence_count @absence_count
end