json.course_identity @user_course_identity
json.homework_type @homework_type
json.course_public @course.is_public == 1
json.is_end @course.is_end
json.main_category_id @main_category.try(:id)
json.main_category_name @main_category.try(:module_name)
json.category_id @category.try(:id)
json.category_name @category.try(:name)

json.homeworks @homework_commons.each do |homework|
  # homework_private = (@user_course_identity > Course::STUDENT) && !homework.is_public
  curr_status = homework_curr_status(homework, @user_course_identity, @course, @member, @member&.teacher_course_groups)
  json.homework_id homework.id
  json.name homework.name
  json.private_icon !homework.is_public
  json.status curr_status[:status]
  json.status_time curr_status[:time]
  json.time_status curr_status[:time_status]
  json.allow_late homework.allow_late
  json.author homework.user&.real_name
  json.author_img url_to_avatar(homework.user)
  json.author_login homework.user&.login
  json.created_at homework.created_at.strftime("%Y-%m-%d")
  # 只有在主目录才显示
  json.upper_category_name homework.course_second_category&.name unless params[:category]

  charge_ids = @course.charge_group_ids(@member)
  json.publish_immediately @user.logged? && @user_course_identity < Course::STUDENT && homework.publish_immediately(charge_ids)
  json.end_immediately @user.logged? && @user_course_identity < Course::STUDENT && homework.end_immediately(charge_ids)

  unless curr_status[:status].include?("未发布")
    work_count = calculate_work_count homework, @member, homework.anonymous_comment && homework&.homework_detail_manual&.student_comment
    json.commit_count work_count[:commit_count]
    json.uncommit_count work_count[:uncommit_count]
    json.all_count work_count[:all_count]
    json.compelete_count work_count[:compelete_count]

    if homework.homework_type != "practice"
      json.uncomment_count work_count[:uncomment_count]
    end
  end

  if homework.homework_type == "practice"
    json.shixun_identifier homework.shixuns.take.try(:identifier)
    json.shixun_status homework.shixuns.take.try(:status).to_i
  end
  if @user_course_identity == Course::STUDENT
    if homework.homework_type == "practice"
      shixun = homework.shixuns.take
      # json.challenge_count homework.shixuns.first.try(:challenges_count).to_i
      current_myshixun = homework.user_work(@user.id).try(:myshixun)
      myshixun = current_myshixun ? current_myshixun : shixun.myshixuns.find_by(user_id: @user.id)
      # json.game_count current_myshixun ? current_myshixun.exec_count : 0
      json.task_operation task_operation_url(myshixun, shixun)
    else
      work = homework.user_work(@user.id)
      json.work_id work.try(:id)
      json.work_status student_work_status(homework, @user.id, @course, work)
      json.un_commit_work !work.present? || work.work_status == 0
    end
  end
end

json.all_count @all_count
json.published_count @published_count
json.unpublished_count @all_count - @published_count
json.task_count @task_count

