json.(item, :name, :item_type, :difficulty, :public, :quotes)
Rails.logger.info("item:#{item.inspect}")
check_answer_role = current_user.id == item.user_id || current_user.admin_or_business? || current_user.is_certification_teacher
json.analysis check_answer_role ? item.analysis : nil
json.choices item.item_choices do |choice|
  json.choice_text choice.choice_text
  json.is_answer choice.is_answer
end
if item.item_type == "PROGRAM"
  json.program_attr do
    json.(item.container, :description, :language, :difficult, :status, :identifier)
    json.language item.container&.language.to_s == "cpp" ? "C++" : item.container&.language
  end
end
# 当为填空题时
if item.item_type == "COMPLETION"
  standard_answers_count = item.item_bank_standard_answers
  # 填空的空数
  standard_answer_ex = standard_answers_count.pluck(:position).uniq
  # json.is_ordered question.is_ordered
  json.multi_count standard_answer_ex.size #有几个填空
  json.standard_answer do
    json.array! standard_answer_ex.each do |a|
      s_answer_text = standard_answers_count.standard_by_positions(a).pluck(:answer_text)
      json.position a
      json.answer_text s_answer_text
    end
  end
  json.is_ordered item.is_ordered
# 当为简答题时
elsif item.item_type == "SUBJECTIVE"
  json.answer_texts item.item_bank_standard_answers.pluck(:answer_text)
end